
#include "main.h"





int WINAPI 
WinMain (HINSTANCE hThisInstance,
         HINSTANCE hPrevInstance,
         LPSTR lpszArgument,
         int nFunsterStil)

{
    // init mojih varijabli:
    szResultat[0] = 0;

    
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           szAppName,       /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           544,                 /* The programs width */
           375,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow (hwnd, nFunsterStil);

    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK
WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    static HWAVEIN      hWaveIn;
    static HWAVEOUT     hWaveOut;
    static PBYTE        pBuffer1, pBuffer2, pSaveBuffer, pNewBuffer;
    static PWAVEHDR     pWaveHdr1, pWaveHdr2;
    static WAVEFORMATEX waveform;
    static DWORD        dwVecSnimljeno;
    static BOOL         bSnimaj, bZavrsavaj = false;
    
    
    static int          cxChar, cyChar; 
    HDC                 hdc;
    PAINTSTRUCT         ps;
    TEXTMETRIC          tm;
    static HWND         KreniDugme, StopirajDugme, PlayDugme, SnimiDugme, IzracunajDugme;
    
    
    switch (message)                  /* handle the messages */
    {
        case WM_CREATE:
            hdc = GetDC( hwnd );
            
            GetTextMetrics( hdc, &tm );
            cyChar = tm.tmHeight + tm.tmExternalLeading;
            cxChar = tm.tmAveCharWidth;
            
            ReleaseDC( hwnd, hdc );
            // Napravi dugmice:
            KreniDugme = CreateWindow( "Button",
                                       szKreniDugmeText,
                                       WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,            
                                       10, 10, // x & y
                                       lstrlen(szKreniDugmeText) * cxChar+2, 
                                       cyChar +2,
                                       hwnd,
                                       (HMENU) idKreniDugme,
                                       ((LPCREATESTRUCT) lParam)->hInstance,
                                       NULL );
            StopirajDugme = CreateWindow( "Button", 
                                          szStopirajDugmeText,
                                          WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                                          10, 40, // x & y
                                          lstrlen( szStopirajDugmeText ) * cxChar+2,
                                          cyChar +2,
                                          hwnd,
                                          (HMENU) idStopirajDugme,
                                          ((LPCREATESTRUCT) lParam)->hInstance,
                                          NULL );
            PlayDugme = CreateWindow( "Button", 
                                      szPlayDugmeText,
                                      WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                                      10, 100, // x & y
                                      lstrlen( szPlayDugmeText ) * cxChar+2,
                                      cyChar +2,
                                      hwnd,
                                      (HMENU) idPlayDugme,
                                      ((LPCREATESTRUCT) lParam)->hInstance,
                                      NULL );   
            SnimiDugme = CreateWindow( "Button", 
                                        szSnimiDugmeText,
                                        WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                                        10, 120, // x & y
                                        lstrlen( szSnimiDugmeText ) * cxChar+2,
                                        cyChar +2,
                                        hwnd,
                                        (HMENU) idSnimiDugme,
                                        ((LPCREATESTRUCT) lParam)->hInstance,
                                        NULL );  
            IzracunajDugme = CreateWindow( "Button", 
                                           szIzracunajDugmeText,
                                           WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                                           10, 140, // x & y
                                           lstrlen( szIzracunajDugmeText ) * cxChar+2,
                                           cyChar +2,
                                           hwnd,
                                           (HMENU) idIzracunajDugme,
                                           ((LPCREATESTRUCT) lParam)->hInstance,
                                           NULL );                      
            // A sada, INIT Wave-a:
            pWaveHdr1 = (PWAVEHDR) malloc( sizeof(WAVEHDR) );
            pWaveHdr2 = (PWAVEHDR) malloc( sizeof(WAVEHDR) );
            pSaveBuffer = (PBYTE) malloc( 1 );
            
            
            return 0;
        case WM_PAINT:
            hdc = BeginPaint( hwnd, &ps );

            TextOut( hdc, 10, 100, szTextOut, lstrlen(szTextOut) );
            
            // Tekst za aplikaciju:
            TextOut( hdc, 10, 70, szKlatschenLabel, lstrlen(szKlatschenLabel) );
            TextOut( hdc, 10 + lstrlen(szKlatschenLabel)*cxChar, 70, szResultat, lstrlen(szResultat) );
            
            EndPaint( hwnd, &ps );
            return 0;
        case WM_COMMAND:
            if( LOWORD(wParam) == idKreniDugme ){
              if( HIWORD(wParam) == BN_CLICKED ){
                /* Kreni sa akcijom !*/
                EnableWindow (KreniDugme, FALSE) ;
                
                // Rezervisi memoriju za dva zaglavlja:
                pBuffer1 = (PBYTE) malloc( INP_BUFFER_SIZE );
                pBuffer2 = (PBYTE) malloc( INP_BUFFER_SIZE );
                
                waveform.wFormatTag      = WAVE_FORMAT_PCM;
                waveform.nChannels       = 1;
                waveform.nSamplesPerSec  = NUM_SAMPLOVA;
                waveform.nAvgBytesPerSec = NUM_SAMPLOVA * NUM_B_PO_SEMPLU /8;
                waveform.nBlockAlign     = 1;
                waveform.wBitsPerSample  = NUM_B_PO_SEMPLU;
                waveform.cbSize          = 0;
                
                // otvori divajs:
                if( waveInOpen( &hWaveIn, WAVE_MAPPER, &waveform, 
                                (DWORD) hwnd, 0, CALLBACK_WINDOW ) ){
                   // ako nije uspelo:
                   free( pBuffer1 );
                   free( pBuffer2 );
                   MessageBox( hwnd, "Desila se greska, ne moze da se otvori rikording divajs...", szAppName, 
                                      MB_ICONEXCLAMATION | MB_OK);
                   
                } else {
                 
                     // init zaglavlja:
                   pWaveHdr1->lpData          = (char*) pBuffer1;
                   pWaveHdr1->dwBufferLength  = INP_BUFFER_SIZE;
                   pWaveHdr1->dwBytesRecorded = 0;
                   pWaveHdr1->dwUser          = 0;
                   pWaveHdr1->dwFlags         = 0;
                   pWaveHdr1->dwLoops         = 1;
                   pWaveHdr1->lpNext          = NULL;
                   pWaveHdr1->reserved        = 0;
                   
                   // Pripremi zaglavlje & ubaci ga:
                   waveInPrepareHeader( hWaveIn, pWaveHdr1, sizeof(WAVEHDR) );
                   
                   
                   pWaveHdr2->lpData          = (char*) pBuffer2 ;
                   pWaveHdr2->dwBufferLength  = INP_BUFFER_SIZE ;
                   pWaveHdr2->dwBytesRecorded = 0;
                   pWaveHdr2->dwUser          = 0;
                   pWaveHdr2->dwFlags         = 0;
                   pWaveHdr2->dwLoops         = 1;
                   pWaveHdr2->lpNext          = NULL;
                   pWaveHdr2->reserved        = 0;
                   waveInPrepareHeader (hWaveIn, pWaveHdr2, sizeof (WAVEHDR));          
                   //MessageBox(hwnd, "Proslo je kliktanje dugmeta...", szAppName, MB_OK);
                }                
              }
            }
            if( LOWORD(wParam) == idStopirajDugme ){
              if( HIWORD(wParam) == BN_CLICKED ){
                // Obustavi... 
                SendMessage( hwnd, WM_STANI_SA_SNIMANJEM, 0, 0 );
                EnableWindow (KreniDugme, TRUE) ;
              }
            }
            if( LOWORD(wParam) == idPlayDugme ){
              if( HIWORD(wParam) == BN_CLICKED ){
                waveform.wFormatTag      = WAVE_FORMAT_PCM;
                waveform.nChannels       = 1;
                waveform.nSamplesPerSec  = NUM_SAMPLOVA;
                waveform.nAvgBytesPerSec = NUM_SAMPLOVA * NUM_B_PO_SEMPLU / 8;
                waveform.nBlockAlign     = 1;
                waveform.wBitsPerSample  = NUM_B_PO_SEMPLU;
                waveform.cbSize          = 0;
                EnableWindow( PlayDugme, false );
                if( waveOutOpen( &hWaveOut, WAVE_MAPPER, &waveform, 
                                (DWORD) hwnd, 0, CALLBACK_WINDOW ) ){
                   MessageBox( hwnd, "Desila se greska sa otvaranjem divajsa...", szAppName, 
                                      MB_ICONEXCLAMATION | MB_OK);
                }
              }
            }
            if( LOWORD( wParam ) == idSnimiDugme ){
              if( HIWORD( wParam ) == BN_CLICKED ){
                EnableWindow( PlayDugme, false );
                FILE *fajl;
                if( fajl = fopen("temp.txt", "w") ){
                  char bufer[10];
                  for( DWORD temp = 0; temp < dwVecSnimljeno; temp++){
                    wsprintf( bufer, "%d\n", (int)((unsigned char)pSaveBuffer[temp]) );
                    fputs( bufer, fajl);
                  }
                  fclose(fajl);
                  EnableWindow( PlayDugme, true );
                } else {
                  MessageBox( hwnd, "Fajl ne moze da se otvori...", szAppName, 
                                      MB_ICONEXCLAMATION | MB_OK);
                }
              }
            }
            if( LOWORD(wParam) == idIzracunajDugme ){
              if( HIWORD(wParam) == BN_CLICKED ){
                DWORD dwR = IzvrsiSveProracune( pSaveBuffer, dwVecSnimljeno );

                // Odstampaj poraz:
                wsprintf( szResultat, "%i         ", dwR );
                hdc = GetDC( hwnd );
                TextOut( hdc, lstrlen(szKlatschenLabel)*cxChar, 70, szResultat, lstrlen(szResultat) ); 
                ReleaseDC( hwnd, hdc);                
              }
            }
            break;
        case WM_DESTROY:
            free ( pWaveHdr1 );
            free ( pWaveHdr2 );
            free ( pSaveBuffer );
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
        case WM_STANI_SA_SNIMANJEM:
            // Prekini:
            bZavrsavaj = true;
            waveInReset( hWaveIn );
            return 0;
        case MM_WIM_OPEN:
            // Vrata Babilona se otvaraju !
            pSaveBuffer = (PBYTE) realloc( pSaveBuffer, 1 );
            
            // Dodaj bufer:
            waveInAddBuffer( hWaveIn, pWaveHdr1, sizeof(WAVEHDR) );
            waveInAddBuffer( hWaveIn, pWaveHdr2, sizeof(WAVEHDR) );
            
            // Babilon'Z brning:
            dwVecSnimljeno = 0;
            waveInStart( hWaveIn ); 
            bSnimaj = true;
            return 0; 
        case MM_WIM_DATA:
            // uvecaj memoriju za snimanje:
            pNewBuffer = (PBYTE) realloc( pSaveBuffer, dwVecSnimljeno + ((PWAVEHDR) lParam)->dwBytesRecorded );
            if ( pNewBuffer == NULL ){
              waveInClose( hWaveIn );
              MessageBox( hwnd, "Nema vise memorije za snimanje pSaveBuffera...", szAppName, 
                            MB_ICONEXCLAMATION | MB_OK);
              return 0;
            }
            pSaveBuffer = pNewBuffer;
            // Snimi ono sto je snimljeno :)
            CopyMemory( pSaveBuffer + dwVecSnimljeno, // snimi iz bafera
                        ((PWAVEHDR) lParam)->lpData, // u temp memoriju
                        ((PWAVEHDR) lParam)->dwBytesRecorded ); // onoliko koliko je novo snimljeno
             dwVecSnimljeno += ((PWAVEHDR) lParam)->dwBytesRecorded;
             
            if( bZavrsavaj ){
              waveInClose( hWaveIn );
              bZavrsavaj = false;
              return 0;
            }
            // Kreni sa novim bajtom:
            waveInAddBuffer( hWaveIn, (PWAVEHDR)lParam, sizeof (WAVEHDR) );      
            return 0;
        case MM_WIM_CLOSE:
            // Ocisti memoriju:
            waveInUnprepareHeader( hWaveIn, pWaveHdr1, sizeof(WAVEHDR) );
            waveInUnprepareHeader( hWaveIn, pWaveHdr2, sizeof(WAVEHDR) );
            free( pBuffer1 );
            free( pBuffer2 );
            
        case MM_WOM_OPEN:
            // init:
            pWaveHdr1->lpData          = (char*) pSaveBuffer ;
            pWaveHdr1->dwBufferLength  = dwVecSnimljeno ;
            pWaveHdr1->dwBytesRecorded = 0 ;
            pWaveHdr1->dwUser          = 0 ;
            pWaveHdr1->dwFlags         = WHDR_BEGINLOOP | WHDR_ENDLOOP ;
            pWaveHdr1->dwLoops         = 1;
            pWaveHdr1->lpNext          = NULL ;
            pWaveHdr1->reserved        = 0 ;    

            waveOutPrepareHeader( hWaveOut, pWaveHdr1, sizeof (WAVEHDR) );
            waveOutWrite( hWaveOut, pWaveHdr1, sizeof (WAVEHDR) );
            return 0;
        case MM_WOM_DONE:
            waveOutUnprepareHeader( hWaveOut, pWaveHdr1, sizeof (WAVEHDR) );
            waveOutClose( hWaveOut );
            EnableWindow( PlayDugme, true );
            return 0;
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}

void Isprintaj( char* text ){
  lstrcpy( szTextOut, text );
  return;
};

void DajRezultat( char* text){
  lstrcpy( szResultat, text );
  return;
};

DWORD IzvrsiSveProracune( PBYTE pSaveBuffer, DWORD dwVelicina ){
  DWORD dwR = 0;
  DWORD dwTemp = 0;
  int iPrvi = 0, iPoslednji = 0;
  bool bFunkcijaSeSpusta;
  int iSastavljenBroj;
  // za poslednji broj:
  // iSastavljenBroj = pSaveBuffer[dwVelicina-2]+pSaveBuffer[dwVelicina-1]<<8;
  
  for( dwTemp = 1; dwTemp < dwVelicina -1; dwTemp += 2 ){
    iSastavljenBroj = pSaveBuffer[dwTemp -1] + pSaveBuffer[dwTemp]<<8;
    if(iSastavljenBroj > 0){ // ako nije tisina:
      iPrvi = iSastavljenBroj;
      if( iPrvi > iPoslednji ){
        // povecavaj spic
        bFunkcijaSeSpusta = false;
      }
      if( iPrvi < iPoslednji && !bFunkcijaSeSpusta){
        // Funkcija se spusta, spic je prosao i to u iPoslednji...
        dwR += iPoslednji;
        bFunkcijaSeSpusta = true;
      }
    }
    iPoslednji = iPrvi;      
  }
  dwR = dwR / dwVelicina;
  return dwR;
}


